unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TsStdCtrls, TsMusicInfo;

type
  TForm1 = class(TForm)
    Edit_Title: TEdit;
    ComboBox_Genre: TComboBox;
    Edit_Artist: TEdit;
    Edit_Comment: TEdit;
    Edit_Album: TEdit;
    Edit_Year: TEdit;
    Panel: TPanel;
    Image: TImage;
    tsLabelText1: TtsLabelText;
    OpenDialog: TOpenDialog;
    LAB_Samplerate: TLabel;
    LAB_Bitrate: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    tsMp3Tag: TtsMp3Tag;
    tsFlacTag: TtsFlacTag;
    tsApeTag: TtsApeTag;
    tsWmaTag: TtsWmaTag;
    Edit_Path: TtsLabBtnEdit;
    procedure Edit_PathRightClick(Sender: TObject);
  private
    { Private declarations }
    procedure GetMusicTag( const Filename: String );
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
  uses
  TsBass;
{$R *.dfm}

procedure TForm1.Edit_PathRightClick(Sender: TObject);
begin
  if OpenDialog.Execute(Handle) then
  begin
    Edit_Path.Text:= OpenDialog.FileName;
    GetMusicTag(OpenDialog.FileName)
  end;
end;

procedure TForm1.GetMusicTag( const Filename: String );
 var
 Ext:    TMExt;
begin
  Image.Picture:= nil;
  LAB_Bitrate.Caption:=  '';
  LAB_Samplerate.Caption:= '';
  Ext:=   GetMusicType(ExtractFileExt(Filename)) ;
  case Ext of
    Ext_Mp3:
    begin
      tsMp3Tag.Filename:=  Filename;
      Image.Picture.Assign(tsMp3Tag.MP3Image);
      Edit_Title.Text:= tsMp3Tag.Title;
      Edit_Artist.Text:= tsMp3Tag.Artist;
      Edit_Comment.Text:= tsMp3Tag.Comment;
      Edit_Album.Text:= tsMp3Tag.Album;
      Edit_Year.Text:= tsMp3Tag.Year;
      ComboBox_Genre.Items:= tsMp3Tag.Genres;
      ComboBox_Genre.ItemIndex:= ComboBox_Genre.Items.IndexOf(tsMp3Tag.Genre);

      if tsMp3Tag.MpegInfo.vbr then
      LAB_Bitrate.Caption:= inttostr(tsMp3Tag.MpegInfo.Bitrate) + 'kbit/s (vbr)'
      ELSE
      LAB_Bitrate.Caption:= inttostr(tsMp3Tag.MpegInfo.Bitrate) + 'kbit/s';

      LAB_Samplerate.Caption := inttostr(tsMp3Tag.MpegInfo.samplerate) + ' Hz, ' + channel_modes[tsMp3Tag.MpegInfo.channelmode];
    end;
    Ext_Ape:
    begin
      tsApeTag.Filename:= Filename;
      Edit_Title.Text:= tsApeTag.Title;
      Edit_Artist.Text:= tsApeTag.Artist;
      Edit_Comment.Text:= tsMp3Tag.Comment;
      Edit_Album.Text:= tsApeTag.Album;
      Edit_Year.Text:= tsApeTag.Year;
      ComboBox_Genre.ItemIndex:= -1;
    end;
    Ext_FLAC:
    begin
      tsFlacTag.Filename:= Filename;
      Edit_Title.Text:= tsFlacTag.Title;
      Edit_Artist.Text:= tsFlacTag.Artist;
      Edit_Album.Text:= tsFlacTag.Album;
      Edit_Year.Text:= tsFlacTag.Year;
      Edit_Comment.Text:= tsFlacTag.Comment;
      ComboBox_Genre.ItemIndex:= ComboBox_Genre.Items.IndexOf(tsFlacTag.Genre);
    end;
    Ext_Wma:
    begin
      tsWmaTag.Filename:= Filename;
      Edit_Title.Text:= tsWmaTag.Title;
      Edit_Artist.Text:= tsWmaTag.Artist;
      Edit_Album.Text:= tsWmaTag.Album;
      Edit_Year.Text:= tsWmaTag.Year;
      Edit_Comment.Text:= tsWmaTag.Comment;
      ComboBox_Genre.ItemIndex:= ComboBox_Genre.Items.IndexOf(tsWmaTag.Genre);
    end;
  end;
end;

end.
