unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TsBass, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Play: TButton;
    Pause: TButton;
    Stop: TButton;
    LAB_Length: TLabel;
    OpenDialog: TOpenDialog;
    Timer: TTimer;
    PaintBox: TPaintBox;
    Timer_Draw: TTimer;
    Background: TButton;
    OpenImage: TOpenDialog;
    Nobackg: TButton;
    ScrollBar: TScrollBar;
    tsBass: TtsBass;
    procedure PlayClick(Sender: TObject);
    procedure PauseClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure Timer_DrawTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BackgroundClick(Sender: TObject);
    procedure NobackgClick(Sender: TObject);
    procedure ScrollBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure tsBassPlay(Sender: TObject);
    procedure tsBassPause(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.NobackgClick(Sender: TObject);
begin
 tsBass.BassFFT.Nobackg;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  with tsBass.BassFFT do
  begin
    PaintWidth:= PaintBox.Width;
    PaintHeight:= PaintBox.Height;
    fpDraw:= 2;
    fpMode:= 1;
    SpectrumHeight:= 62;
  end;
  tsBass.BassDll.EnabledStream:= True;
  tsBass. LoadBass:= True;
end;

procedure TForm1.BackgroundClick(Sender: TObject);
begin
 if OpenImage.Execute(Handle) then tsBass.BassFFT.SetBackground(OpenImage.FileName);
end;

procedure TForm1.PauseClick(Sender: TObject);
begin
 tsBass.Pause;
end;

procedure TForm1.PlayClick(Sender: TObject);
begin
  if OpenDialog.FileName = '' then
  begin
    if OpenDialog.Execute(Handle) then
    begin
      tsBass.LoadFromFile(OpenDialog.FileName);
      tsBass.Play();
    end;
  end
  else tsBass.Play();
end;

procedure TForm1.ScrollBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  tsBass.Position:= ScrollPos;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
  tsBass.Stop;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  ScrollBar.Position:= Trunc(tsbass.Position);
  LAB_Length.Caption:= tsBass.GetLengthStr()+' / '+tsbass.GetLengthStr(false);
end;

procedure TForm1.Timer_DrawTimer(Sender: TObject);
begin
  tsBass.BassFFT.fpRender(PaintBox.Canvas,-1,-1);
end;

procedure TForm1.tsBassPause(Sender: TObject);
begin
  Timer.Enabled:= False;
  Timer_Draw.Enabled:= False;
end;

procedure TForm1.tsBassPlay(Sender: TObject);
begin
  ScrollBar.Max:= Trunc( tsBass.MLength );
  LAB_Length.Caption:= tsBass.GetLengthStr()+' / '+tsbass.GetLengthStr(false);
  Timer.Enabled:= True;
  Timer_Draw.Enabled:= True;
end;

end.
