unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TsNet, TsStdCtrls, StdCtrls, ComCtrls, TsDialog;

type
  TForm1 = class(TForm)
    tsDownLoadFile: TtsDownLoadFile;
    Edit_URL: TtsLabeledEdit;
    Edit_Filename: TtsLabBtnEdit;
    Btn_DownLoad: TButton;
    ProgressBar: TProgressBar;
    StatusBar: TStatusBar;
    tsMessageBox: TtsMessageBox;
    SaveDialog: TSaveDialog;
    procedure Btn_DownLoadClick(Sender: TObject);
    procedure tsDownLoadFileDownLoadProgress(Progress, ProgressMax: Cardinal;
      const sProgress, sProgressMax, sSpeeds: string; var Cancel: Boolean);
    procedure tsDownLoadFileBeforeDownload(Sender: TObject);
    procedure Edit_FilenameRightButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
     uses
     TsBasisUnit;
{$R *.dfm}

procedure TForm1.Btn_DownLoadClick(Sender: TObject);
begin
  if ( Edit_URL.Text <> '' ) and
     ( DirectoryExists(ExtractFilePath(Edit_Filename.Text)) )
  then
  begin
    ClearIECache();
    tsDownLoadFile.URL:= Edit_URL.Text;
    tsDownLoadFile.Filename:= Edit_Filename.Text;
    tsDownLoadFile.Execute;
  end
  else tsMessageBox.MbWarningDlg('');
end;

procedure TForm1.Edit_FilenameRightButtonClick(Sender: TObject);
begin
  if SaveDialog.Execute then
  Edit_Filename.Text:= SaveDialog.FileName;
end;

procedure TForm1.tsDownLoadFileBeforeDownload(Sender: TObject);
begin
  ProgressBar.Max:= 0;
end;

procedure TForm1.tsDownLoadFileDownLoadProgress(Progress, ProgressMax: Cardinal;
  const sProgress, sProgressMax, sSpeeds: string; var Cancel: Boolean);
begin
  if ProgressBar.Max <> ProgressMax then ProgressBar.Max:= ProgressMax;  
  with StatusBar do
  begin
    Panels[1].Text:= sProgressMax;
    Panels[3].Text:= sProgress;
    Panels[5].Text:= sSpeeds;
  end;
  ProgressBar.Position:= Progress;
end;

end.
