unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TsOaFile, StdCtrls, TsNVCp;

type
  TForm1 = class(TForm)
    Memo: TMemo;
    Btn_BC: TButton;
    Btn_BD: TButton;
    Btn_EC: TButton;
    Btn_ED: TButton;
    tsMessageBox: TtsMessageBox;
    tsFileMonitoring: TtsFileMonitoring;
    procedure Btn_BCClick(Sender: TObject);
    procedure Btn_ECClick(Sender: TObject);
    procedure Btn_BDClick(Sender: TObject);
    procedure Btn_EDClick(Sender: TObject);
    procedure tsFileMonitoringItems0ChangeInfo(const CHDateTime, OldFname,
      NewFName: string; const FileOperation: Integer);
    procedure FormShow(Sender: TObject);
    procedure tsFileMonitoringItems0Terminate(const Error: Boolean;
      const ADDEDCount, REMOVEDCount, RENAMECount, MODIFIEDCount,
      UNKNOWNCount: Integer);
    procedure tsFileMonitoringItems1Terminate(const Error: Boolean;
      const ADDEDCount, REMOVEDCount, RENAMECount, MODIFIEDCount,
      UNKNOWNCount: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
   uses
   TsClassesUnit;
{$R *.dfm}

procedure TForm1.Btn_BDClick(Sender: TObject);
begin
 tsFileMonitoring.Items[1].Start;
 Btn_BD.Enabled:= False;
 Btn_ED.Enabled:= True;
end;

procedure TForm1.Btn_ECClick(Sender: TObject);
begin
 tsFileMonitoring.Items[0].Stop;
  Btn_BC.Enabled:= True;
 Btn_EC.Enabled:= False;
end;

procedure TForm1.Btn_EDClick(Sender: TObject);
begin
 tsFileMonitoring.Items[1].Stop;
  Btn_BD.Enabled:= True;
  Btn_ED.Enabled:= False;
end;

procedure TForm1.FormShow(Sender: TObject);
 var
 Path:  TtsSystemFolders;
begin
   Path:= TtsSystemFolders.Create;
   try
     tsFileMonitoring.Items[0].Path:= Path.Desktop;
   finally
     FreeAndNil(path);
   end;
end;

procedure TForm1.Btn_BCClick(Sender: TObject);
begin
 tsFileMonitoring.Items[0].Start;
 Btn_BC.Enabled:= False;
 Btn_EC.Enabled:= True;
end;

procedure TForm1.tsFileMonitoringItems0ChangeInfo(const CHDateTime, OldFname,
  NewFName: string; const FileOperation: Integer);
begin
  case FileOperation of
    ADDED:  Memo.Lines.Add('ļ -> ' + oldfname + '  ' + chdatetime);
    REMOVED: Memo.Lines.Add('ɾļ -> ' + oldfname + '  ' + chdatetime);
    RENAME: Memo.Lines.Add('ļ -> ' + oldfname + ' Ϊ >  ' + NewFName + '   ' +CHDateTime);
    MODIFIED: Memo.Lines.Add('޸ļ -> ' + oldfname + '  ' + chdatetime);
    5: Memo.Lines.Add('δ֪仯 -> ' + oldfname + '  ' + chdatetime);
  end;
end;

procedure TForm1.tsFileMonitoringItems0Terminate(const Error: Boolean;
  const ADDEDCount, REMOVEDCount, RENAMECount, MODIFIEDCount,
  UNKNOWNCount: Integer);
begin
  if Error then
  begin
    tsMessageBox.MbInformationDlg( ' . ' +#13#10+#13#10+
    'ļ: ' + IntToStr(ADDEDCount) +#13#10+
    'ɾļ: ' + IntToStr(REMOVEDCount) +#13#10+
    'ļ: ' + IntToStr(RENAMECount) +#13#10+
    '޸ļ: ' + IntToStr(MODIFIEDCount) +#13#10+
    'δ֪ļ仯: ' + IntToStr(UNKNOWNCount) );
  end
  else
  begin
    Btn_BC.Enabled:= True;
    Btn_EC.Enabled:= False;
  end;
end;

procedure TForm1.tsFileMonitoringItems1Terminate(const Error: Boolean;
  const ADDEDCount, REMOVEDCount, RENAMECount, MODIFIEDCount,
  UNKNOWNCount: Integer);
begin
  if Error then
  begin
    tsMessageBox.MbInformationDlg( ' C. ' +#13#10+#13#10+
    'ļ: ' + IntToStr(ADDEDCount) +#13#10+
    'ɾļ: ' + IntToStr(REMOVEDCount) +#13#10+
    'ļ: ' + IntToStr(RENAMECount) +#13#10+
    '޸ļ: ' + IntToStr(MODIFIEDCount) +#13#10+
    'δ֪ļ仯: ' + IntToStr(UNKNOWNCount) );
  end
  else
  begin
    Btn_BD.Enabled:= True;
    Btn_ED.Enabled:= False;
  end;
end;

end.
