unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls,  TsNVCp, XPMan;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ListView: TListView;
    Button1: TButton;
    tsProcessList: TtsProcessList;
    Label1: TLabel;
    Label2: TLabel;
    Panel2: TPanel;
    Memo1: TMemo;
    dllList: TListView;
    XPManifest1: TXPManifest;
    procedure Button1Click(Sender: TObject);
    procedure tsProcessListReadTerminate(const ProcCount: Integer);
    procedure FormShow(Sender: TObject);
    procedure ListViewClick(Sender: TObject);
    procedure dllListClick(Sender: TObject);
    procedure tsProcessListGetModulesChang(const Module, ModulePath: string;
      const ModuleID, ModBaseSize, GlblCntUsage: Cardinal;
      const IconIndex: Integer);
    procedure FormCreate(Sender: TObject);
    procedure tsProcessListReadChange(const eName, Path, CmdLine: string;
      const dwSize, cntUsage, th32ProcessID, th32DefaultHeapID, th32ModuleID,
      cntThreads, th32ParentProcessID, pcPriClassBase, dwFlags, Filesize,
      ImageBase: Cardinal; const IconIdx: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
  uses
  TsGraphicsUnit,
    TsBasisUnit;
{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 ListView.Items.Clear;
 tsProcessList.ReadProcessList;
end;

procedure TForm1.dllListClick(Sender: TObject);
var
P:  string;
begin
  if dllList.Selected <> nil then
  begin
    P:= dllList.Selected.SubItems[0];
    if ExtractFileExt(P)='.dll' then
    begin
      Memo1.Clear;
      Memo1.Lines.Add(dllList.Selected.Caption + ' ĵ');
      Memo1.Lines.AddStrings( tsProcessList.GetDLLExports(PChar(P)));
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetListViewImages(ListView.Handle,1);
  SetListViewImages(ListView.Handle,1);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 Button1Click(nil);
end;

procedure TForm1.ListViewClick(Sender: TObject);
var
D:        DWORD;
begin
 if ListView.Selected <> nil then
 begin
   d:=StrToInt(ListView.Selected.SubItems[1]);
   Label2.Caption:= tsProcessList.GetPMC(D);
   dllList.Items.Clear;
     tsProcessList.GetModules(D);
 end;
end;

procedure TForm1.tsProcessListGetModulesChang(const Module, ModulePath: string;
  const ModuleID, ModBaseSize, GlblCntUsage: Cardinal;
  const IconIndex: Integer);
begin
  with dllList.Items.Add do
  begin
    Caption:= Module;
    SubItems.Add(ModulePath);
    SubItems.Add(IntToStr(GlblCntUsage));
    SubItems.Add(IntToHex(ModBaseSize, 8));
    ImageIndex:= IconIndex;
  end;
end;

procedure TForm1.tsProcessListReadChange(const eName, Path, CmdLine: string;
  const dwSize, cntUsage, th32ProcessID, th32DefaultHeapID, th32ModuleID,
  cntThreads, th32ParentProcessID, pcPriClassBase, dwFlags, Filesize,
  ImageBase: Cardinal; const IconIdx: Integer);
begin
   with ListView.Items.Add do
  begin
    Caption:= eName;
    SubItems.Add(Path);
    SubItems.Add(IntToStr(th32ProcessID));
    SubItems.Add(FormatSize(Filesize));
    SubItems.Add(CmdLine);
    ImageIndex:= IconIdx;
  end;
end;

procedure TForm1.tsProcessListReadTerminate(const ProcCount: Integer);
begin
 Label1.Caption:= '̸: ' +  IntToStr(ProcCount) + '  .';
end;

end.
