unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TsOaFile, ExtCtrls, ComCtrls, TsNVCp, StdCtrls, TsDialog, TsStdCtrls;

type
  TForm1 = class(TForm)
    tsMessageBox: TtsMessageBox;
    ListView: TListView;
    Panel: TPanel;
    Label1: TLabel;
    ExtList: TComboBox;
    Check_CaseSensitive: TCheckBox;
    Check_SubFolder: TCheckBox;
    Btn_Stop: TButton;
    Btn_Find: TButton;
    tsDirDialog: TtsDirDialog;
    Edit_Path: TtsLabBtnEdit;
    tsSearchFile: TtsSearchFile;
    procedure Btn_FindClick(Sender: TObject);
    procedure Btn_StopClick(Sender: TObject);
    procedure tsSearchFileTerminate(const FileCount: Integer;
      const Allfilesize: Cardinal);
    procedure tsSearchFileStart(Sender: TObject);
    procedure tsSearchFileFileMatch(FileInfo: TFileInfo);
    procedure Edit_PathRightClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
TsBasisUnit;
{$R *.dfm}

procedure TForm1.Btn_FindClick(Sender: TObject);
begin
  if not DirectoryExists(Edit_Path.Text) then
  begin
   tsMessageBox.MbWarningDlg('Ŀ¼ַȷ.');
   Exit;
  end;

  with tsSearchFile do
  begin
    Basic.Clear;
    Basic.CaseSensitive:= Check_CaseSensitive.Checked;
    Basic.Subfolders:= Check_SubFolder.Checked;
    Basic.Path:= Edit_Path.Text;
    Basic.Extensions.Add(ExtList.Text);
    Execute;
  end;
end;

procedure TForm1.Btn_StopClick(Sender: TObject);
begin
  tsSearchFile.Terminate;
end;

procedure TForm1.Edit_PathRightClick(Sender: TObject);
begin
 if tsDirDialog.Execute then Edit_Path.Text:= tsDirDialog.DirPath;
end;

procedure TForm1.tsSearchFileFileMatch(FileInfo: TFileInfo);
begin
  with ListView.Items.Add do
  begin
    Caption:= FileInfo.Filename;
    SubItems.Add(FormatSize(FileInfo.FileSize));
    SubItems.Add(DateTimeToStr(FileInfo.CreatedTime));
    SubItems.Add(DateTimeToStr(FileInfo.ModifiedTime));
    SubItems.Add(DateTimeToStr(FileInfo.AccessedTime));
  end;
end;

procedure TForm1.tsSearchFileStart(Sender: TObject);
begin
   Btn_Find.Enabled:= False;
 Btn_Stop.Enabled:= True;
end;

procedure TForm1.tsSearchFileTerminate(const FileCount: Integer;
  const Allfilesize: Cardinal);
begin
     Btn_Find.Enabled:= True;
   Btn_Stop.Enabled:= False;
       tsMessageBox.MbInformationDlg('ɨ赽ļ: ' + IntToStr(FileCount) + ' .'+#13#10+
   'ļС: ' + FormatSize(Allfilesize ));
end;

end.
