unit HookUint;

interface
    uses
    Windows;
{-------------------------------------------------------------------------------}
function HookSendTo(Handle:  THandle):Boolean;stdcall;
function UnHookSendTo(Handle:  THandle):Boolean;stdcall;
//------------------------------------------------------------------------------
exports
  HookSendTo,
  UnHookSendTo;
//------------------------------------------------------------------------------
implementation
  uses
    TsBasisUnit,
    WinSock,
    SysUtils,
    JclPeImage,
    JclSysUtils;
//------------------------------------------------------------------------------
const
  STATUS_FAILED = $FFFF; //쳣
  MAX_PACK_LEN = 65535; //յIP
  MAX_ADDR_LEN = 16; //ʮƵַ󳤶
  MAX_PROTO_TEXT_LEN = 16; //Э("TCP")󳤶
  MAX_PROTO_NUM = 12; //Э
  MAX_HOSTNAME_LAN = 255; //
  CMD_PARAM_HELP = true;

  IOC_IN = $80000000;
  IOC_VENDOR = $18000000;
  IOC_out = $40000000;
  SIO_RCVALL = IOC_IN or IOC_VENDOR or 1; // or IOC_out;
  SIO_RCVALL_MCAST = IOC_IN or IOC_VENDOR or 2;
  SIO_RCVALL_IGMPMCAST = IOC_IN or IOC_VENDOR or 3;
  SIO_KEEPALIVE_VALS = IOC_IN or IOC_VENDOR or 4;
  SIO_ABSORB_RTRALERT = IOC_IN or IOC_VENDOR or 5;
  SIO_UCAST_IF = IOC_IN or IOC_VENDOR or 6;
  SIO_LIMIT_BROADCASTS = IOC_IN or IOC_VENDOR or 7;
  SIO_INDEX_BIND = IOC_IN or IOC_VENDOR or 8;
  SIO_INDEX_MCASTIF = IOC_IN or IOC_VENDOR or 9;
  SIO_INDEX_ADD_MCAST = IOC_IN or IOC_VENDOR or 10;
  SIO_INDEX_DEL_MCAST = IOC_IN or IOC_VENDOR or 11;

type
  _iphdr = record
    h_lenver: byte; //4λײ+4λIP汾
    tos: char; //8λTOS
    total_len: char; //16λܳȣֽڣ
    ident: word; //16λʶ
    frag_and_flags: word; //3λ־λ
    ttl: byte; //8λʱ TTL
    proto: byte; //8λЭ (TCP, UDP )
    checksum: word; //16λIPײУ
    sourceIP: Longword; //32λԴIPַ
    destIP: Longword; //32λĿIPַ
  end;
  IP_HEADER = _iphdr;

type _tcphdr = record //TCPײ
    TCP_Sport: word; //16λԴ˿
    TCP_Dport: word; //16λĿĶ˿
    th_seq: longword; //32λк
    th_ack: longword; //32λȷϺ
    th_lenres: byte; //4λײ/6λ
    th_flag: char; //6λ־λ
    th_win: word; //16λڴС
    th_sum: word; //16λУ
    th_urp: word; //16λƫ
  end;
  TCP_HEADER = _tcphdr;
type _udphdr = record //UDPײ
    uh_sport: word; //16λԴ˿
    uh_dport: word; //16λĿĶ˿
    uh_len: word; //16λ
    uh_sum: word; //16λУ
  end;
  UDP_HEADER = _udphdr;
type _icmphdr = record //ICMPײ
    i_type: byte; //8λ
    i_code: byte; //8λ
    i_cksum: word; //16λУ
    i_id: word; //ʶţһý̺Ϊʶţ
    //	i_seq           :word;	     	//к
    timestamp: word; //ʱ
  end;
  ICMP_HEADER = _icmphdr;

type _protomap = record //Эӳ
    ProtoNum: integer;
    ProtoText: array[0..MAX_PROTO_TEXT_LEN] of char;
  end;
  TPROTOMAP = _protomap;

const
Ws2_32 = 'wsock32.dll';
var
  ImportHooks: TJclPeMapImgHooks;
  OldSendto: function (s: TSocket; const buf; len, flags: Integer; toaddr: PSockAddr; tolen: Integer): Integer; stdcall;
  type
  TOnHookPro = procedure(ip, proto, sourceIP, destIP, SourcePort, DestPort: string;
                          header: pchar; header_size: integer;
                          data: pchar; data_size: integer);
{-------------------------------------------------------------------------------}
function IsIpAddress(const strIp: string): Boolean;
var
  i,
  j:          Smallint;
  k:          array[1..5] of smallint;
  strTemp:    string;
begin
  Result:= False;

  if Length(strIp) > 15 then Exit;
  for i:= 1 to Length(strIp) do if not (strIp[i] in ['0'..'9', '.']) then Exit;
  j:= 0;
  for i:= 1 to Length(strIp) do if (strIp[i] = '.') then j := j + 1;
  if j <> 3 then Exit;
  strTemp:= '.' + strIp + '.';
  j:= 0;
  for i := 1 to Length(strTemp) do if (strTemp[i] = '.') then
  begin
    Inc(j);
    k[j]:= i;
  end;

  for i:= 2 to 5 do
  if Length(Copy(strTemp, k[i - 1] + 1, k[i] - k[i - 1] - 1)) > 3 then Exit;

  Result := True;
end;

function CheckProtocol(iProtocol: integer): string;
begin
  case iProtocol of
    IPPROTO_IP: result:= 'IP';
    IPPROTO_ICMP: result:= 'ICMP';
    IPPROTO_IGMP: result:= 'IGMP';
    IPPROTO_GGP: result:= 'GGP';
    IPPROTO_TCP: result:= 'TCP';
    IPPROTO_PUP: result:= 'PUP';
    IPPROTO_UDP: result:= 'UDP';
    IPPROTO_IDP: result:= 'IDP';
    IPPROTO_ND: result:= 'NP';
    IPPROTO_RAW: result:= 'RAW';
    IPPROTO_MAX: result:= 'MAX';
  else
    result:= '';
  end;
end;

procedure DecodeIpPack(ip: string; buf: pchar; iBufSize: integer; OnHookPro:  TOnHookPro);
  var
  SourcePort,
  DestPort:      word;
  IphLen,
  data_size,
  Protocol:      Integer;
  sProtocol:     array[0..MAX_PROTO_TEXT_LEN] of char;
  sSourceIP:     array[0..MAX_ADDR_LEN] of char;
  sDestIP:       array[0..MAX_ADDR_LEN] of char;
  TcpHeader:     TCP_HEADER;
  UdpHeader:     UDP_HEADER;
  IcmpHeader:    ICMP_HEADER;
  saSource,
  saDest:        TSockAddrIn;
  TcpData:       PChar;
  Ipheader:      IP_HEADER;
begin
  CopyMemory(@Ipheader, buf, sizeof(Ipheader));
  Protocol:= Ipheader.proto;
  StrLCopy(sProtocol, pchar(CheckProtocol(Protocol)), 15);

  saSource.sin_addr.s_addr := Ipheader.sourceIP;
  strlcopy(sSourceIP, inet_ntoa(saSource.sin_addr), MAX_ADDR_LEN);

  saDest.sin_addr.s_addr:= Ipheader.destIP;
  strLcopy(sDestIP, inet_ntoa(saDest.sin_addr), MAX_ADDR_LEN);

  IphLen:= sizeof(Ipheader);
  case Protocol of
    IPPROTO_TCP:
    begin
      CopyMemory(@TcpHeader, buf + IphLen, sizeof(TcpHeader));
      SourcePort:= ntohs(TcpHeader.TCP_Sport); //Դ˿
      DestPort:= ntohs(TcpHeader.TCP_Dport); //ĿĶ˿
      TcpData:= buf + IphLen + sizeof(TcpHeader);
      data_size:= iBufSize - IphLen - sizeof(TcpHeader);
    end;
    IPPROTO_UDP:
    begin
      CopyMemory(@UdpHeader, buf + IphLen, sizeof(UdpHeader));
      SourcePort := ntohs(UdpHeader.uh_sport); //Դ˿
      DestPort := ntohs(UdpHeader.uh_dport); //ĿĶ˿
      TcpData := buf + IphLen + sizeof(UdpHeader);
      data_size := iBufSize - IphLen - sizeof(UdpHeader);
    end;
    IPPROTO_ICMP:
    begin
      CopyMemory(@IcmpHeader, buf + IphLen, sizeof(IcmpHeader));
      SourcePort:= IcmpHeader.i_type; //
      DestPort:= IcmpHeader.i_code; //
      TcpData:= buf + IphLen + sizeof(IcmpHeader);
      data_size:= iBufSize - IphLen - sizeof(IcmpHeader);
    end;
  else
    SourcePort := 0;
    DestPort:= 0; //
    TcpData:= buf + IphLen;
    data_size:= iBufSize - IphLen;
  end;

  if Cardinal(@OnHookPro) <> 0 then
                                  OnHookPro(ip,
                                           sProtocol,
                                           sSourceIP,
                                           sDestIP,
                                           inttostr(SourcePort),
                                           inttostr(DestPort),
                                           buf,
                                           iBufSize - data_size,
                                           TcpData,
                                           data_size);
end;

procedure HookPro(ip, proto, sourceIP, destIP, SourcePort, DestPort: string;
                          header: pchar; header_size: integer;
                          data: pchar; data_size: integer);
begin
  if proto = 'UDP' then
  begin
    if (data_size = 27) and (PByte(data)^ = $3) then
    begin
      MessageBox(0,PChar( sourceIP + ' -> ' + DestPort ),'Test',0);
    end;
  end;
end;

function NewSendto( S: TSocket;
                    const buf;
                    len, flags: Integer;
                    toaddr: PSockAddr;
                    tolen: Integer): Integer; stdcall;
var
  Sip:          string;
  RecvBuf:      array[0..MAX_PACK_LEN] of char;
begin
  MessageBox(0,'Then is a test!','Test',0);
  Sip:= inet_ntoa(toaddr^.sin_addr) ;
  if IsIpAddress(Sip) then
  begin
    fillchar(RecvBuf, sizeof(RecvBuf), 0);
    if recv(s,RecvBuf, SizeOf(RecvBuf),0) <>  SOCKET_ERROR then
    DecodeIpPack(Sip,RecvBuf,SizeOf(RecvBuf),HookPro);
  end;
  Result:= OldSendto(s,buf,len,flags,toaddr,tolen) ;
end;

function HookSendTo(Handle:  THandle):Boolean;stdcall;
begin
  Result:=  ImportHooks.HookImport(Pointer(Handle),
                        Ws2_32,
                        'sendto',
                        @NewSendto,
                        @OldSendto);
end;

function UnHookSendTo(Handle:  THandle):Boolean;stdcall;
begin
  Result:= ImportHooks.UnhookByNewAddress(@NewSendto);
  if Result then @OldSendto:= nil;
end;
{-------------------------------------------------------------------------------}
initialization
  ImportHooks := TJclPeMapImgHooks.Create;
finalization
  FreeAndNil(ImportHooks);
end.
