unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TsNet, ComCtrls, TsExtCtrls, StdCtrls, ExtCtrls, TsStdCtrls, TsNVCp,
  TsDialog;

type
  TForm1 = class(TForm)
    tsUdpSocket: TtsUdpSocket;
    tsPanel: TtsPanel;
    ListView: TListView;
    Label1: TLabel;
    ComboBox: TComboBox;
    Button: TButton;
    tsPing1: TtsPing;
    tsLabeledEdit: TtsLabeledEdit;
    tsMessageBox: TtsMessageBox;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure ComboBoxSelect(Sender: TObject);
    procedure ListViewDblClick(Sender: TObject);
    procedure tsUdpSocketError(Sender: TObject; Error: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tsUdpSocketReceive(Sender: TObject);
    procedure ButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
//function HookSendTo(Handle:  THandle):Boolean;stdcall;external 'HookSendTo.dll';
//function UnHookSendTo(Handle:  THandle):Boolean;stdcall; external 'HookSendTo.dll';

implementation
  uses
  HookUint,
  WinSock;
{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
    tsUdpSocket.Broadcast:= True;
  tsUdpSocket.LocalPort:= 2012;
  tsUdpSocket.RemotePort:= 1986;
  tsUdpSocket.Open;
  Button1.Enabled:= False;
  Button2.Enabled:= True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  tsUdpSocket.Close;
  Button1.Enabled:= True;
  Button2.Enabled:= False;
end;

procedure TForm1.ButtonClick(Sender: TObject);
begin
  tsUdpSocket.RemoteHost:= ComboBox.Text;
  tsUdpSocket.SendText(tsLabeledEdit.Text);
end;

procedure TForm1.ComboBoxSelect(Sender: TObject);
begin
  tsUdpSocket.BindTo:= ComboBox.Text;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tsUdpSocket.Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   if HookSendTo(HInstance) then
 Text:= 'Ok';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  HookSendTo(HInstance);
end;

procedure TForm1.FormShow(Sender: TObject);
  var
  IpList:  in_addr_list;
  I:       Integer;
begin
    if GetIPByName('', IpList) then
  begin
    for I:= 0 to High( IpList ) do
    ComboBox.Items.Add(inet_ntoa(IpList[I]));

    ComboBox.ItemIndex:= 0;
  end
  else ComboBox.Enabled:= False;
end;

procedure TForm1.ListViewDblClick(Sender: TObject);
begin
  if ListView.Selected <> nil then
  begin
    tsUdpSocket.RemoteHost:= ListView.Selected.SubItems[0];
    tsUdpSocket.SendText('ô?');
  end;
end;

procedure TForm1.tsUdpSocketError(Sender: TObject; Error: Integer);
begin
  tsMessageBox.MbWarningDlg('UDP: ' + IntToStr(Error));
end;

procedure TForm1.tsUdpSocketReceive(Sender: TObject);
  function IndexOfID(const AMCID: String): TListItem;
    var
    I:   Integer;
  begin
    for i := 0 to ListView.Items.Count-1 do
    begin
      Result:= ListView.Items.Item[i];
      if (Result.Caption = AMCID) then  Exit;
    end;
    Result := NIL;
  end;
  var
    IP:         in_addr;
    Port:       Integer;
    ListItem:   TListItem;
    Rs:         string;
begin
  Rs:= tsUdpSocket.ReceiveText(IP, Port);
  if (Rs <> '') then
  begin
    ListItem := IndexOfID(Rs);
    if Assigned(ListItem) then
      ListItem.SubItems[2] := TimeToStr(Now)
    else
    begin
      ListItem:= ListView.Items.Add;
      with ListItem do
      begin
        Caption:= Rs;
        SubItems.Add(inet_ntoa(IP));
        SubItems.Add(IntToStr(Port));
        SubItems.Add(TimeToStr(Now));
      end;
    end;
  end;
end;

end.
