unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TsNet, StdCtrls, ExtCtrls, TsStdCtrls;

type
  TForm1 = class(TForm)
    tsUdpSocket: TtsUdpSocket;
    CheckBox: TCheckBox;
    tsLabeledEdit: TtsLabeledEdit;
    Memo: TMemo;
    procedure CheckBoxClick(Sender: TObject);
    procedure tsUdpSocketReceive(Sender: TObject);
    procedure tsUdpSocketError(Sender: TObject; Error: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
   uses
   TsBasisUnit,
   WinSock;
{$R *.dfm}

procedure TForm1.CheckBoxClick(Sender: TObject);
begin
  tsUdpSocket.Listen:= CheckBox.Checked;
  if tsUdpSocket.Listen then
     Memo.Lines.Add('')
  else Memo.Lines.Add('');
  if tsUdpSocket.Listen <> CheckBox.Checked then CheckBox.Checked:= False;   
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  tsUdpSocket.LocalPort:= 1986;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Randomize;
  tsLabeledEdit.Text:= MD5DigestToStr(MD5String( IntToStr( Random(-1986 ) ) ));
end;

procedure TForm1.tsUdpSocketError(Sender: TObject; Error: Integer);
begin
  Memo.Lines.Add( 'UDP: '+IntToStr(Error) );
end;

procedure TForm1.tsUdpSocketReceive(Sender: TObject);
  var
    IP:      in_addr;
    Port:    Integer;
    Rs:      string;
begin
  with  tsUdpSocket, Memo do
  begin
    Rs:= ReceiveText(IP, Port);
    Lines.Add(Format(' %s:%d> %s', [inet_ntoa(IP), Port, Rs]));
    tsUdpSocket.RemoteAddr:= IP;

    RemotePort:= Port;
    SendText(tsLabeledEdit.Text);
  end;
end;

end.
