unit Unit1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  TsStdCtrls;

type
  TForm1 = class(TForm)
    tsLabelText: TtsLabelText;
    TsBinaryList_Demo: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    tsRegistry_Demo: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    tsLabelText1: TtsLabelText;
    tsIniFile_Demo: TGroupBox;
    Button5: TButton;
    Button6: TButton;
    tsLabelText2: TtsLabelText;
    tsDataFileBuild_Demo: TGroupBox;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
   uses
   TsBasisUnit,
   TsClassesUnit;
{$R *.dfm}
  var
  FWav:    TtsWavePlayer;
procedure TForm1.Button1Click(Sender: TObject);
  const
    P1 = 'AAAAAAAAAAAAAA5156+165196849849489494/8S4DSSSSSSSSSSSDADWDWA1D6+5AS15D1SA65D11';
    p2 = 'BBBBBBBBBBBBADWQDADASDA202402.021WDWQDWQDWQ484FC98S498S4F98FSD4FF9SD14V8SD94V98SD4F';
  var
  BinList:  TtsBinaryList;
begin
  BinList:= TtsBinaryList.Create;
  try
    with BinList.Add() do
    begin
      Name:= '˭';
      Tag:= 1;
      Add(PAnsiChar(P1),Length(P1));
    end;

    with BinList.Add() do
    begin
      Name:= 'Test2';
      Tag:= 2;
      Add(PAnsiChar(P2),Length(P2));
    end;
    BinList.SaveToFile(ExtractFilePath(Application.ExeName) + '1.bin');
  finally
    FreeAndNil(BinList);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
  var
  BinList:  TtsBinaryList;
begin
  BinList:= TtsBinaryList.Create;
  try
    BinList.LoadFromFile(ExtractFilePath(Application.ExeName) + '1.bin');
    with tsLabelText,BinList[1]do
    begin
      Lines.add(Name);
      Lines.Add('Size: ' + IntToStr(Size));
      Lines.Add(PAnsiChar(Binary));
    end;
  finally
    FreeAndNil(BinList);
  end;
end;

const
PKEY = 'Software\tsRegistry';
PName = 'Test';
procedure TForm1.Button3Click(Sender: TObject);
  var
  Reg:  TtsRegistry;
begin
  Reg.RootKey:= HKEY_CURRENT_USER;
  Reg.CreatKey(PKEY);
  with Reg.GetKeyItem(PKEY) do
  StringValues[PName]:= 'Hello World.';
end;

procedure TForm1.Button4Click(Sender: TObject);
  var
  Reg:  TtsRegistry;
begin
  Reg.RootKey:= HKEY_CURRENT_USER;
  Reg.CreatKey(PKEY);
  with Reg.GetKeyItem(PKEY) do
   tsLabelText1.Lines.Text:= StringValues[PName];
end;

procedure TForm1.Button5Click(Sender: TObject);
  var
  M:  TtsIniFile;
begin
  M:= TtsIniFile.Create;
  try
    with M.AddSection('T') do
    begin
      StringValues['A']:= 'Hello World.';
      Int64Values['B']:= TtsDateTime.EncodeDateTime(2013,9,4,0,0,0);
    end;
    M.SaveToFile(ExtractFilePath(Application.ExeName) + '1.ini');
  finally
    FreeAndNil(M);
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
  var
  I:  Integer;
  M:  TtsIniFile;
begin
  M:= TtsIniFile.Create;
  try
    M.LoadFromFile(ExtractFilePath(Application.ExeName) + '1.ini');
    I:= M.GetSectionIndex('T');
    if I <> -1 then
    begin
      with M.Sections[I],tsLabelText2.Lines do
      begin
        Add( StringValues['A'] );
        Add( TtsDateTime.DateToStr( Int64Values['B'],'YYYY-MM-DD' ));
      end;
    end;
  finally
    FreeAndNil(M);
  end;
end;


const
PTag  =  20130904;
procedure TForm1.Button7Click(Sender: TObject);
  var
  BData:  TtsDataFileBuild;
  P:      string;
begin
  P:= ExtractFilePath(Application.ExeName);
  BData:= TtsDataFileBuild.Create;
  try
    BData.Tag:= PTag;

    BData.WriteFile(P + 'Music.wav','Music');
    BData.WriteFile(P + 'Text.txt','Text');
    BData.SaveDataToFile(P + '1.dat') ;
  finally
    FreeAndNil(BData);
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
  var
  BData:  TtsDataFileBuild;
  M:      TMemoryStream;
begin
  BData:= TtsDataFileBuild.Create;
  try
    BData.LoadFromDataFile(PTag,ExtractFilePath(Application.ExeName) + '1.dat');
    M:=   TMemoryStream.Create;
    try
      if BData.ExtractData(0,M) then
      begin
        M.Position:= 0;
        FWav.LoadFromStream(M);
        if FWav.Play then ;
      end;
    finally
      FreeAndNil(M);
    end;
  finally
    FreeAndNil(BData);
  end;
end;

procedure TForm1.Button9Click(Sender: TObject);
  var
  BData:  TtsDataFileBuild;
  M:      TStringStream;
begin
  BData:= TtsDataFileBuild.Create;
  try
    BData.LoadFromDataFile(PTag,ExtractFilePath(Application.ExeName) + '1.dat');
    M:=   TStringStream.Create(SC_None,TEncoding.UTF8);
    try
      if BData.ExtractData(1,M) then
        ShowMessage(M.DataString);
    finally
      FreeAndNil(M);
    end;
  finally
    FreeAndNil(BData);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FWav:= TtsWavePlayer.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FWav);
end;

end.
